; Assembler optimized routines for synth_1to1() for WatcomC
;
; Petteri Kangaslampi <pekangas@sci.fi>
;
; Based on the optimized synth_1to1 cod by Stefan Bieschewski <stb@acm.org>


SEGMENT DATA PUBLIC ALIGN=16 CLASS=DATA USE32

buffs:	times 4352 DB 0
bo	DD	1

temp	DD	0

EXTERN _decwin


SEGMENT CODE PUBLIC ALIGN=16 CLASS=CODE USE32

EXTERN _dct64

%ifdef notdef
GLOBAL	synth_1to1_1_pent_

synth_1to1_1_pent_:
	push	ebp

	mov	ebp,edi
	xor	edx,edx

	add	ebp,64

.looppi:
	fld	dword [esi]
	fmul	dword [ebx]		; 0*0(0)
	fld	dword [esi+4]		; 0*0(1)
	fmul	dword [ebx+4]		; 1*1(0), 0*0(2)
	fxch	st1,st0
	fld	dword [esi+8]
	fmul	dword [ebx+8]		; 2*2(0), 0*0, 1*1(2)
	fxch	st2,st0
	fsubrp	st1,st0			; 0-1(0), 2*2(1)
	fld	dword [esi+12]
	fmul	dword [ebx+12]		; 3*3(0), s(2), 2*2
	fxch	st2,st0
	faddp	st1,st0			; s(0), 3*3(1)
	fld	dword [esi+16]
	fmul	dword [ebx+16]		; ...
	fxch	st2,st0
	fsubrp	st1,st0
	fld	dword [esi+20]
	fmul	dword [ebx+20]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [esi+24]
	fmul	dword [ebx+24]
	fxch	st2,st0
	fsubrp	st1,st0
	fld	dword [esi+28]
	fmul	dword [ebx+28]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [esi+32]
	fmul	dword [ebx+32]
	fxch	st2,st0
	fsubrp	st1,st0
	fld	dword [esi+36]
	fmul	dword [ebx+36]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [esi+40]
	fmul	dword [ebx+40]
	fxch	st2,st0
	fsubrp	st1,st0
	fld	dword [esi+44]
	fmul	dword [ebx+44]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [esi+48]
	fmul	dword [ebx+48]
	fxch	st2,st0
	fsubrp	st1,st0
	fld	dword [esi+52]
	fmul	dword [ebx+52]
	fxch	st2,st0         
	faddp	st1,st0
	fld	dword [esi+56]
	fmul	dword [ebx+56]
	fxch	st2,st0
	fsubrp	st1,st0
	fld	dword [esi+60]
	fmul	dword [ebx+60]
	fxch	st2,st0
	faddp	st1,st0			; s(0), 15*15(2)
	fxch	st1,st0
	fsubrp	st1,st0
	fistp	dword [temp]
	mov	eax,[temp]
	cmp	eax,32767
	jg	.a1
	cmp	eax,-32768
	jl	.a2
	mov	[edi],ax
	jmp	.a4
.a1:	mov	word [edi],32767
	jmp	.a3
.a2:	mov	word [edi],-32768
.a3:	inc	edx

.a4:
	add	esi,128
	add	ebx,64

	add	edi,4

	cmp	edi,ebp
	jb	near .looppi

	mov	eax,edx

	pop	ebp
	ret
%endif


GLOBAL synth_1to1_pent_

synth_1to1_pent_:
	; Hackhack, emulate cdecl:
	push	ebx
	push	edx
	push	eax
	push	ecx ;save this, also acts as the "return address"

	sub	esp,12
	push	ebp
	push	edi
	push	esi
	push	ebx

	mov	eax,[esp+32]	; eax = bandPtr
	mov	esi,[esp+40]	; esi = samples
	xor	edi,edi

	mov	ebp,[bo]
	cmp	[esp+36],edi	; channel == 0?
	jne	.l_48
	dec	ebp
	and	ebp,15
	mov	[bo],ebp
	mov	ecx,buffs	; ecx = buf = buffs[0]
	jmp	.l_49

.l_48:
	add	esi,2
	mov	ecx,buffs+2176	; ecx = buf = buffs[1]
.l_49
	test	ebp,1
	jz	.l_50
			; bo & 0x1
	mov	ebx,ecx		; ebx = buf[0]
	mov	[esp+16],ebp	; bo1 = bo
	push	eax		; bandPtr
	mov	edx,[esp+20]
	lea	eax,[ebx+4*edx]
	push	eax		; buf[0] + bo
	mov	eax,[esp+24]
	inc	eax
	and	eax,15
	lea	eax,[1088+4*eax]
	add	eax,ebx		; buf[1] + ((bo+1) & 0xf)
	jmp	.l_74

.l_50:
	lea	ebx,[1088+ecx]	; ebx = buf[1]
	lea	edx,[ebp+1]	; edx = bo + 1
	mov	[esp+16],edx	; bo1 = bo + 1
	push	eax		; bandptr
	lea	eax,[1092+ecx+4*ebp]
	push	eax		; buf[1] + bo + 1
	lea	eax,[ecx+4*ebp]	; buf[0] + bo

.l_74:
	push	eax
	call	_dct64
	add	esp,12
	mov	edx,[esp+16]
	lea	edx,[4*edx]
	mov	eax,_decwin+64
	mov	ecx,eax
	sub	ecx,edx		; ecx = window = decwin + 16 - bo1
	mov	ebp,16		; ebx = b0

.l_55:
	fld	dword [ecx]
	fmul	dword [ebx]
	fld	dword [ecx+4]
	fmul	dword [ebx+4]
	fxch	st1,st0
	fld	dword [ecx+8]
	fmul	dword [ebx+8]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx+12]
	fmul	dword [ebx+12]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+16]
	fmul	dword [ebx+16]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx+20]
	fmul	dword [ebx+20]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+24]
	fmul	dword [ebx+24]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx+28]
	fmul	dword [ebx+28]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+32]
	fmul	dword [ebx+32]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx+36]
	fmul	dword [ebx+36]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+40]
	fmul	dword [ebx+40]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx+44]
	fmul	dword [ebx+44]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+48]
	fmul	dword [ebx+48]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx+52]
	fmul	dword [ebx+52]
	fxch	st2,st0         
	faddp	st1,st0
	fld	dword [ecx+56]
	fmul	dword [ebx+56]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx+60]
	fmul	dword [ebx+60]
	fxch	st2,st0
	sub	esp,4
	faddp	st1,st0
	fxch	st1,st0
	fsubp	st1,st0
	fistp	dword [esp]
	pop 	eax
	cmp	eax,32767
	jg	.a1
	cmp	eax,-32768
	jl	.a2
	mov	[esi],ax
	jmp	.a4
.a1:	mov	word [esi],32767
	jmp	.a3
.a2:	mov	word [esi],-32768
.a3:	inc	edi

.a4:
.l_54:
	add	ebx,64
	sub	ecx,-128
	add	esi,4
	dec	ebp
	jnz	near .l_55

	fld	dword [ecx]
	fmul	dword [ebx]
	fld	dword [ecx+8]
	fmul	dword [ebx+8]
	fld	dword [ecx+16]
	fmul	dword [ebx+16]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+24]
	fmul	dword [ebx+24]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+32]
	fmul	dword [ebx+32]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+40]
	fmul	dword [ebx+40]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+48]
	fmul	dword [ebx+48]
	fxch	st2,st0
	faddp	st1,st0
	fld	dword [ecx+56]
	fmul	dword [ebx+56]
	fxch	st2,st0
	sub	esp,4
	faddp	st1,st0
	fxch	st1,st0
	faddp	st1,st0
	fistp	dword [esp]
	pop	eax

	cmp	eax,32767
	jg	.b1
	cmp	eax,-32768
	jl	.b2
	mov	[esi],ax
	jmp	.b4
.b1:	mov	word [esi],32767
	jmp	.b3
.b2:	mov	word [esi],-32768
.b3:	inc	edi

.b4:
.l_62:
	add	ebx,-64
	add	esi,4
	mov	edx,[esp+16]
	lea	ecx,[-128+ecx+8*edx]
	mov	ebp,15
.l_68:
	fld	dword [ecx-4]
	fchs
	fmul	dword [ebx]
	fld	dword [ecx-8]
	fmul	dword [ebx+4]
	fxch	st1,st0
	fld	dword [ecx-12]
	fmul	dword [ebx+8]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-16]
	fmul	dword [ebx+12]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-20]
	fmul	dword [ebx+16]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-24]
	fmul	dword [ebx+20]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-28]
	fmul	dword [ebx+24]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-32]
	fmul	dword [ebx+28]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-36]
	fmul	dword [ebx+32]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-40]
	fmul	dword [ebx+36]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-44]
	fmul	dword [ebx+40]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-48]
	fmul	dword [ebx+44]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-52]
	fmul	dword [ebx+48]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-56]
	fmul	dword [ebx+52]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx-60]
	fmul	dword [ebx+56]
	fxch	st2,st0
	fsubp	st1,st0
	fld	dword [ecx]
	fmul	dword [ebx+60]
	fxch	st2,st0
	sub	esp,4
	fsubp	st1,st0
	fxch 	st1,st0
	fsubp	st1,st0
	fistp	dword [esp]
	pop	eax

	cmp	eax,32767
	jg	.c1
	cmp	eax,-32768
	jl	.c2
	mov	[esi],ax
	jmp	.c4
.c1:	mov	word [esi],32767
	jmp	.c3
.c2:	mov	word [esi],-32768
.c3:	inc	edi

.c4:
.l_67:
	add	ebx,-64
	add	ecx,-128
	add	esi,4
	dec	ebp
	jnz	near .l_68
	mov	eax,edi
	pop	ebx
	pop	esi
	pop	edi
	pop	ebp
	add	esp,12

	; Hackhack, emulate cdecl:
	pop	ecx
	pop	edx	; don't mess the return value
	pop	edx
	pop	ebx

	ret
